// ==UserScript==
// @name       TUIO to touchevent
// @namespace  http://use.i.E.your.homepage/
// @version    0.2
// @description  Converts TUIO touches to javascript touch events automatically, requires npTuioClient NPAPI plugin
// @match      http://*/*
// @match      https://*/*
// @copyright  2012+, You
// ==/UserScript==

if (window.top != window.self)  //-- Don't run on frames or iframes
    return;

magicTouchScript = (
"// Framework for simulating touch events without a mobile device\n" + 
"// Trying to be compatible with\n" + 
"//  http://dvcs.w3.org\/hg\/webevents\/raw-file\/tip\/touchevents.html\n" + 
"// TODO: support more of the touch API: touch{enter, leave, cancel}\n" + 
"var tuio = {\n" + 
"    cursors: [],\n" + 
"    activeTarget: null,\n" + 
"\n" + 
"  // Data structure for associating cursors with objects\n" + 
"    _data: {},\n" + 
"\n" + 
"  _touchstart:    function(touch) {\n" + 
"    // Create a touchstart event\n" + 
"    this._create_event(\'touchstart\', touch, {});\n" + 
"  },\n" + 
"\n" + 
"  _touchmove: function(touch) {\n" + 
"    // Create a touchmove event\n" + 
"    this._create_event(\'touchmove\', touch, {});\n" + 
"  },\n" + 
"\n" + 
"  _touchend: function(touch) {\n" + 
"    // Create a touchend event\n" + 
"    this._create_event(\'touchend\', touch, {});\n" + 
"  },\n" + 
"\n" + 
"  _create_event: function(name, touch, attrs) {\n" + 
"    // Creates a custom DOM event\n" + 
"    var evt = document.createEvent(\'CustomEvent\');\n" + 
"    evt.initEvent(name, true, true);\n" + 
"    // Attach basic touch lists\n" + 
"    evt.touches = this.cursors;\n" + 
"    // Get targetTouches on the event for the element\n" + 
"    evt.targetTouches = this._get_target_touches(touch.target);\n" + 
"    evt.changedTouches = [touch];\n" + 
"    // Attach custom attrs to the event\n" + 
"    for (var attr in attrs) {\n" + 
"      if (attrs.hasOwnProperty(attr)) {\n" + 
"        evt[attr] = attrs[attr];\n" + 
"      }\n" + 
"    }\n" + 
"    // Dispatch the event\n" + 
"    if (touch.target) {\n" + 
"      touch.target.dispatchEvent(evt);\n" + 
"    } else {\n" + 
"      document.dispatchEvent(evt);\n" + 
"    }\n" + 
"  },\n" + 
"\n" + 
"  _get_target_touches: function(element) {\n" + 
"    var targetTouches = [];\n" + 
"    for (var i = 0; i < this.cursors.length; i++) {\n" + 
"      var touch = this.cursors[i];\n" + 
"      if (touch.target == element) {\n" + 
"        targetTouches.push(touch);\n" + 
"      }\n" + 
"    }\n" + 
"    return targetTouches;\n" + 
"  },\n" + 
"\n" + 
"    // Callback from the main event handler\n" + 
"    callback: function(type, sid, fid, x, y, angle) {\n" + 
"        var data;\n" + 
"\n" + 
"        if (type !== 3) {\n" + 
"            data = this._data[sid];\n" + 
"        } else {\n" + 
"            data = {\n" + 
"                sid: sid,\n" + 
"                fid: fid\n" + 
"            };\n" + 
"            this._data[sid] = data;\n" + 
"        }\n" + 
"\n" + 
"        // Some properties\n" + 
"        // See http://dvcs.w3.org\/hg\/webevents\/raw-file\/tip\/touchevents.html\n" + 
"        data.identifier = sid;\n" + 
"        data.pageX = window.innerWidth * x + window.pageXOffset;\n" + 
"        data.pageY = window.innerHeight * y + window.pageYOffset;\n" + 
"        data.clientX = window.innerWidth * x;\n" + 
"        data.clientY = window.innerHeight * y;\n" + 
"        data.screenX = window.innerWidth * x;\n" + 
"        data.screenY = window.innerHeight * y;\n" + 
"    \n" + 
"        if (this.activeTarget == null) {\n" + 
"            this.activeTarget = document.elementFromPoint(data.clientX, data.clientY);\n" + 
"        }\n" + 
"    \n" + 
"        data.target = this.activeTarget;\n" + 
"\n" + 
"        switch (type) {\n" + 
"            case 3:\n" + 
"                this.cursors.push(data);\n" + 
"                this._touchstart(data);\n" + 
"                break;\n" + 
"\n" + 
"            case 4:\n" + 
"                this._touchmove(data);\n" + 
"                break;\n" + 
"\n" + 
"            case 5:\n" + 
"                this.cursors.splice(this.cursors.indexOf(data), 1);\n" + 
"                this._touchend(data);\n" + 
"                if (this.cursors.length == 0) {\n" + 
"                    this.activeTarget = null;\n" + 
"                }\n" + 
"                break;\n" + 
"\n" + 
"            default:\n" + 
"                break;\n" + 
"        }\n" + 
"\n" + 
"        if (type === 5) {\n" + 
"            delete this._data[sid];\n" + 
"        }\n" + 
"    }\n" + 
"\n" + 
"};\n" +
"function tuio_callback(type, sid, fid, x, y, angle)    {" + 
//"    console.log(\"type: \" + type + \"  sid: \" + sid + \"  x: \" + x + \"  y: \" + y + \"  angle: \" + angle);" + 
"    tuio.callback(type, sid, fid, x, y, angle);" + 
"}"
    );

function contentEval(source) {
  // Check for function input.
  if ('function' == typeof source) {
    // Execute this function with no arguments, by adding parentheses.
    // One set around the function, required for valid syntax, and a
    // second empty set calls the surrounded function.
    source = '(' + source + ')();'
  }

  // Create a script node holding this  source code.
  var script = document.createElement('script');
  script.setAttribute("type", "application/javascript");
  script.textContent = source;

  // Insert the script node into the page, so it will run, and immediately
  // remove it to clean up.
  document.body.appendChild(script);
  document.body.removeChild(script);
}

addTuio = true

var elements = document.getElementsByTagName('object')
for (var i = 0; i < elements.length; i++) {
    if (elements[i].id.toLowerCase() == "tuio") {
        console.log("Not adding tuio object, already exists in document");
		addTuio = false
    }
}

if (addTuio) {
    var newobj = document.createElement("object");
    newobj.width=0
    newobj.height=0
    newobj.type="application/x-tuio"
    newobj.id="tuio"
    newobj.appendChild(document.createTextNode("Touch plug-in failed to load!"));
    document.body.appendChild(newobj);
}

contentEval(magicTouchScript);

console.log("Added TUIO to touchevent");
